$   ver = 'F$VERIFY(0)
$   GOTO TREESIZE
$!
$!  PROCEDURE TREESIZE
$!
$!  Computes the number of blocks in the directory structure given
$!  as the argument.  The structure is assumed to be a DECUS dir-
$!  ectory structure on the disk whose name is in DCL Symbol
$!  VAXSIG$DISK.
$!
$!  To save time, we do not always need to count the blocks; this
$!  procedure saves the count in a file, and if the same structure
$!  is called for again in a subsequent call, it simply reads the
$!  count from the file; this is not done for [VAX000] and its com-
$!  ponents, since its size can change.  For example, the size of
$!  [VAX82B...] is saved in the file 'VAX82B.SIZ'.
$!
$!  The output of this procedure is the global DCL symbol BLOCKS.
$!
$ TREESIZE:
$   ON CONTROL_Y THEN  GOTO CLEANUP
$   ON ERROR     THEN  GOTO CLEANUP
$!
$   WRITE SYS$OUTPUT "
Computing number of blocks in ",p1
$!
$   name = ""
$!
$   IF F$LOCATE("[VAX000",p1) .EQS. 0 THEN  GOTO COUNT
$!
$   name = procdir + F$EXTRACT(1,6,p1) + ".SIZ"
$!
$   IF F$SEARCH(name) .EQS. "" THEN  GOTO COUNT
$!
$   OPEN  TTEMP 'name'
$   READ  TTEMP blocks
$   CLOSE TTEMP
$!
$   blocks == blocks
$   DELETE /SYMBOL /LOCAL blocks
$   GOTO EXIT
$   
$ COUNT:
$   IF name .NES. "" THEN -
	WRITE SYS$OUTPUT "
		This is going to take a while..."
$!
$   DIR /SIZE /GRAND /OUTPUT=COPYTREES.TMP 'VAXSIG$DISK':'p1'
$!
$   OPEN TTEMP COPYTREES.TMP
$   READ /END=END TTEMP line
$   READ /END=END TTEMP line	! Info we want is on second line
$   CLOSE TTEMP
$   DELETE COPYTREES.TMP;*
$!
$   blocks == F$ELEMENT(2,",",line) - " blocks." - " "
$!
$   IF name .EQS. "" THEN  GOTO EXIT
$!
$   OPEN /WRITE TTEMP 'name'
$   WRITE TTEMP blocks
$   CLOSE TTEMP
$!
$ EXIT:
$   WRITE SYS$OUTPUT "
",p1," Contains ",blocks," Blocks.
"
$!
$ PAD:
$   blocks == f$int(blocks)		! Won't pad character symbol
$   blocks == F$FAO("!6UL",blocks)	! Pad to six characters for label
$!
$ CLEANUP:
$   SET NOON
$   CLOSE /NOLOG TTEMP
$   IF F$SEARCH("COPYTREES.TMP") .NES. "" THEN  DELETE COPYTREES.TMP;*
$!
$ DONE:
$   IF ver THEN  SET VERIFY
